package Faker::Plugin::Telephone;

use 5.014;

use strict;
use warnings;

use registry;
use routines;

use Data::Object::Class;
use Data::Object::ClassHas;

extends 'Data::Object::Plugin';

our $VERSION = '1.04'; # VERSION

# ATTRIBUTES

has 'faker' => (
  is => 'ro',
  isa => 'ConsumerOf["Faker::Maker"]',
  req => 1,
);

# METHODS

method format_for_number() {
  [
    '###-###-####',
    '###-###-####',
    '### ### ####',
    '### ### ####',
    '### ### ####',
    '### ### ####',
    '(###) ###-####',
    '(###) ###-####',
    '(###) ###-####',
    '(###) ###-####',
    '+##(#)##########',
    '+##(#)##########',
    '0##########',
    '0##########',
    '###-###-####',
    '(###) ### ####',
    '1-###-###-####',
    '###.###.####',
    '###-###-####',
    '### ### ####',
    '##########',
    '(###) ###-####',
    '1-###-###-####',
    '###.###.####',
    '###-###-####x###',
    '(###)###-####x###',
    '1-###-###-####x###',
    '###.###.####x###',
    '###-###-#### x####',
    '(###)###-####x####',
    '1-###-###-####x####',
    '###.###.####x####',
    '###-###-####x#####',
    '(###)###-####x#####',
    '1-###-###-####x#####',
    '###.###.#### x#####'
  ]
}

1;
